#!/usr/bin/env python
"""

Dump or list a range of shots from a database in a nice table

     Copyright (C) 2005  Kurt Schwehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Id: segysqldump.py,v 1.2 2005/09/11 02:37:04 schwehr Exp $

"""

# These values end up in the pydoc web page
__version__ = '$Revision: 1.2 $' # See man ident
__date__ = '$Date: 2005/09/11 02:37:04 $' # FIX: pull out just the date
__author__ = 'Kurt Schwehr'
__credits__ = """LSD inspired... the program, not the drug"""

import sqlite
import os
import sys

BOMBASTIC= 4
VERBOSE  = 3
TRACE    = 2
TERSE    = 1
ALWAYS   = 0


from optparse import OptionParser

vcvs = "$Revision: 1.2 $"
vcvs = vcvs[vcvs.find(':')+2:]
vcvs = vcvs[:vcvs.find('$')-1]
version_cvs = vcvs
del (vcvs) # stop polution

# Track the version of segy-py.  If I use setup.py, which one gets imported?
from segy_version import VERSION

myparser = OptionParser(usage="%prog [options]",
                      version="%prog "+VERSION+' - '+version_cvs)
myparser.add_option('-d','--database',dest='dbfilename',default='segy.db',
                    help='Database containing imported segy file and trace header info [default: %default]')

myparser.add_option('-n','--nth-trace',dest='nthTrace',type='int',default='500',
                    help='How many trace entries to skip before writing out a label [default: %default]')


myparser.add_option('-v',action="count",dest='verbosity',default=0,
                    help='how information to give.  Specify multiple times to increase verbosity')
myparser.add_option('--verbosity',dest='verbosity',type='int',
                    help='Specify verbosity.  Should be in the range of '
                    +str(ALWAYS)+'...'+str(BOMBASTIC)+' (None...Bombastic)')


######################################################################
if __name__ == "__main__":
    (options,args) = myparser.parse_args()

    if options.verbosity >= TRACE:
        print "Verbosity = ", options.verbosity

    fields = []
    fields.append('fileKey')
    fields.append('traceNumber')
    fields.append('X')
    fields.append('Y')
    #fields.append('GrpX')
    #fields.append('GrpY')
    fields.append('EnsembleNo')
    fields.append('FieldRecNo')
    fields.append('Xensemble')
    fields.append('Yensemble')
    fields.append('Year')
    fields.append('Day')
    fields.append('Hour')
    fields.append('Min')
    fields.append('Shotpoint')
    fields.append('TraceNoEnsemble')


    fieldStr = fields[0]
    for i in fields[1:]:
        fieldStr += ','+i
    
    searchStr  = "SELECT "+fieldStr
    searchStr += " FROM segyTrace"
    searchStr += " WHERE traceNumber % "+str(options.nthTrace)+"= 0"
    #if (None != options.minFileKey): searchStr += ' fileKey>='+str(options.minFileKey)
    #if (None != options.minFileKey) and (None != options.maxFileKey): searchStr += ' and'
    #if (None != options.maxFileKey): searchStr += ' fileKey<='+str(options.maxFileKey)
    searchStr += ';'

    print searchStr
    
    
    cx = sqlite.connect(options.dbfilename)
    cu = cx.cursor()

    width = 10
    cu.execute(searchStr)
    count = 0;
    for row in cu.fetchall():
        if count%50 == 0:
            print
            for field in fields:
                while len(field)<width: field += ' '
                print field,' ',
            print '\n'
        count += 1
        for field in fields:
            val = str(row[field])
            while len(val)<width: val += ' '
            print val,' ',
        print
